diff -urp user_import_orig/user_import.module user_import/user_import.module
--- user_import_orig/user_import.module	2008-05-15 15:16:31.000000000 +0200
+++ user_import/user_import.module	2008-06-18 15:56:24.000000000 +0200
@@ -841,11 +861,11 @@ function theme_user_import_list() {
       // header labels
       $import_label = ($import['setting'] == 'tested' || $import['setting'] == 'test') ? t('importable') : t('imported');
       $header = array(t('file'), t('started'), t('processed'), $import_label, t('errors'), t('status'));
-                  
+
       // info row
-      $errors = db_result(db_query("SELECT COUNT(import_id) FROM {user_import_errors} WHERE import_id = %d", $import['import_id']));         
-      $errors_link = ($errors == 0) ? '0': l($errors, 'admin/user/user_import/errors/' . $import['import_id']);           
-      
+      $errors = db_result(db_query("SELECT COUNT(import_id) FROM {user_import_errors} WHERE import_id = %d", $import['import_id']));
+      $errors_link = ($errors == 0) ? '0': l($errors, 'admin/user/user_import/errors/'. $import['import_id']);
+
       $rows[0] = array(
           check_plain($import['oldfilename']),
           format_date($import['started'], 'small'),
@@ -854,21 +874,21 @@ function theme_user_import_list() {
           array("data" => $errors_link, "align" => 'center'),
           $import['setting'],
       );
-      
+
       $output .= theme('table', $header, $rows);
-      
+
       // action buttons
-      $settings_link = l(t('Settings'), 'admin/user/user_import/add/' . $import['import_id']);
-      $delete_link = l(t('Delete'), 'admin/user/user_import/delete/' . $import['import_id']);
-      $continue_link = l(t('Continue Processing'), 'admin/user/user_import/continue/' . $import['import_id']);
-      $import_link = l(t('Import'), 'admin/user/user_import/import/' . $import['import_id']);
-      
-      $output .= $settings_link  . ' | ';   
-      $output .= $delete_link;   
-      if ($import['setting'] == 'tested' || $import['setting'] == 'test') $output .= ' | ' . $import_link;
-      if ($import['setting'] == 'test' || $import['setting']  == 'import') $output .= ' | ' . $continue_link;
-  } 
-  
+      $settings_link = l(t('Settings'), 'admin/user/user_import/add/'. $import['import_id']);
+      $delete_link = l(t('Delete'), 'admin/user/user_import/delete/'. $import['import_id']);
+      $continue_link = l(t('Continue Processing'), 'admin/user/user_import/continue/'. $import['import_id']);
+      $import_link = l(t('Import'), 'admin/user/user_import/import/'. $import['import_id']);
+
+      $output .= $settings_link  .' | ';
+      $output .= $delete_link;
+      if ($import['setting'] == 'tested' || $import['setting'] == 'test') $output .= ' | '. $import_link;
+      if ($import['setting'] == 'test' || $import['setting']  == 'import') $output .= ' | '. $continue_link;
+  }
+
   return $output;
 }
 
@@ -881,11 +901,11 @@ function theme_user_import_limited_list(
   // header labels
   $import_label = ($import['setting'] == 'tested' || $import['setting'] == 'test') ? t('importable') : t('imported');
   $header = array(t('file'), t('started'), t('processed'), $import_label, t('errors'), t('status'));
-              
+
   // info row
-  $errors = db_result(db_query("SELECT COUNT(import_id) FROM {user_import_errors} WHERE import_id = %d", $import['import_id']));         
-  $errors_link = ($errors == 0) ? '0': l($errors, 'user_import/errors/' . $import_id . '/' . $template_id);           
-  
+  $errors = db_result(db_query("SELECT COUNT(import_id) FROM {user_import_errors} WHERE import_id = %d", $import['import_id']));
+  $errors_link = ($errors == 0) ? '0': l($errors, 'user_import/errors/'. $import_id .'/'. $template_id);
+
   $rows[0] = array(
       check_plain($import['oldfilename']),
       format_date($import['started'], 'small'),
@@ -894,26 +914,26 @@ function theme_user_import_limited_list(
       array("data" => $errors_link, "align" => 'center'),
       $import['setting'],
   );
-  
+
   $output .= theme('table', $header, $rows);
-  
+
   // action buttons
-  $delete_link = l(t('Remove Info'), 'user_import/delete/' . $import_id . '/' . $template_id);
-  $continue_link = l(t('Continue Processing'), 'user_import/continue/' . $import_id . '/' . $template_id);
-  $import_link = l(t('Import'), 'user_import/import/' . $import_id . '/' . $template_id);
-  
-  $output .= $delete_link;   
-  if ($import['setting'] == 'tested' || $import['setting'] == 'test') $output .= ' | ' . $import_link;
-  if ($import['setting'] == 'test' || $import['setting']  == 'import') $output .= ' | ' . $continue_link;
+  $delete_link = l(t('Remove Info'), 'user_import/delete/'. $import_id .'/'. $template_id);
+  $continue_link = l(t('Continue Processing'), 'user_import/continue/'. $import_id .'/'. $template_id);
+  $import_link = l(t('Import'), 'user_import/import/'. $import_id .'/'. $template_id);
+
+  $output .= $delete_link;
+  if ($import['setting'] == 'tested' || $import['setting'] == 'test') $output .= ' | '. $import_link;
+  if ($import['setting'] == 'test' || $import['setting']  == 'import') $output .= ' | '. $continue_link;
+
 
-  
   return $output;
 }
 
 function theme_user_import_edit_form($form) {
-    
+
     $header = array(t('csv column'), t('Drupal fields'), t('username'), t('abbreviate'));
-    
+
     foreach (element_children($form['field_match']) as $key) {
 
         $rows[] = array(
@@ -923,7 +943,7 @@ function theme_user_import_edit_form($fo
             drupal_render($form['field_match'][$key]['abbreviate']),
         );
     }
-    
+
     $form['field_match']['#value'] = theme('table', $header, $rows);
 
     $output .= drupal_render($form['remove']);
@@ -935,111 +955,105 @@ function theme_user_import_edit_form($fo
 
 function theme_user_import_errors_display($settings, $data, $total) {
 
-    $error_count = 0;
-    $field_match = _user_import_unconcatenate_field_match($settings['field_match']);
-    $header[0] = t('Email Address');
-
-    foreach ($data as $data_row) {
-
-        $row = NULL;
-        
-        foreach ($data_row['data'] as $type => $fields) {
-   
-          if (!empty($fields)) {
-          
-            foreach ($fields as $field_id => $field_data) {
-  
-              foreach ($field_match as $column_info) {
-              
-                if ($column_info['type'] ==  $type && $column_info['field_id'] == $field_id) {
-                  
-                  if (!empty($column_info['username'])) { 
-                    $header[$column_info['username']] = t('Name %sort', array('%sort' => $column_info['username']));
-                    $row[$column_info['username']] = array("data" => $field_data[0], "align" => "left");
-                  }
-                  
-                  if ($column_info['field_id'] == 'email') { 
-                    $row[0] = array("data" => $field_data[0], "align" => "left");
-                  }
-                }
+  $error_count = 0;
+  $field_match = _user_import_unconcatenate_field_match($settings['field_match']);
+  $header[0] = t('Email Address');
+
+  foreach ($data as $data_row) {
+    $row = NULL;
+
+    foreach ($data_row['data'] as $type => $fields) {
+      if (!empty($fields)) {
+        foreach ($fields as $field_id => $field_data) {
+          foreach ($field_match as $column_info) {
+            if ($column_info['type'] ==  $type && $column_info['field_id'] == $field_id) {
+              if (!empty($column_info['username'])) {
+                $header[$column_info['username']] = t('Name %sort', array('%sort' => $column_info['username']));
+                $row[$column_info['username']] = array("data" => $field_data[0], "align" => "left");
+              }
+              if ($column_info['field_id'] == 'email') {
+                $row[0] = array("data" => $field_data[0], "align" => "left");
               }
-            
-            } 
-          }  
+            }
+          }
         }
-  
-        ksort($row);
-        $row[] = implode('<br />', $data_row['errors']);
-        $rows[] = $row;
-    }
-    
-    $output .= '<p>' . t('<strong>CSV File:</strong> %file', array('%file' => $settings['oldfilename'])) . '<br />';
-    $output .= t('<strong>Errors:</strong> !total', array('!total' => $total)) . '</p>';
+      }
+    }
 
-    $header['errors'] = t('Errors');
-    $output .= theme('table', $header, $rows);    
-    return $output;
+    ksort($row);
+
+    if ($data_row['errors'] !== false ) {
+      $row[] = 'User exists and "Update account" is not enabled.';
+    }
+    $rows[] = $row;
+  }
+
+  $output .= '<p>'. t('<strong>CSV File:</strong> %file', array('%file' => $settings['oldfilename'])) .'<br />';
+  $output .= t('<strong>Errors:</strong> !total', array('!total' => $total)) .'</p>';
+
+  $header['errors'] = t('Errors');
+  $output .= theme('table', $header, $rows);
+  return $output;
 }
 
 function theme_user_import_username_errors($errors) {
-    
+
     if (empty($errors)) {
-        $output = '<p><strong>' . t('All usernames are OK.') . '</strong></p>';
-    } else {
+        $output = '<p><strong>'. t('All usernames are OK.') .'</strong></p>';
+    }
+    else {
         $header = array(t('User ID'), t('Email'), t('Username'), t('Error'));
         $output = theme('table', $header, $errors);
     }
-    
+
     return $output;
 }
 
-// - - - - - - - -  MISC - - - - - - - - 
+// - - - - - - - -  MISC - - - - - - - -
 
 function user_import_edit_file_fields(&$form, $import) {
-    
-    $form['filename'] = array(
-        '#type' => 'value',
-        '#value' => $import['filename'],
-    );
-    
-    $form['oldfilename'] = array(
-        '#type' => 'value',
-        '#value' => $import['oldfilename'],
-    );
-    
-    $form['filepath'] = array(
-        '#type' => 'value',
-        '#value' => $import['filepath'],
-    );
-    
-    return;
+  $form['filename'] = array(
+    '#type' => 'value',
+    '#value' => $import['filename'],
+  );
+
+  $form['oldfilename'] = array(
+    '#type' => 'value',
+    '#value' => $import['oldfilename'],
+  );
+
+  $form['filepath'] = array(
+    '#type' => 'value',
+    '#value' => $import['filepath'],
+  );
+
+  return;
 }
 
 function user_import_form_field_match(&$form, $import) {
-
   $collapsed = (empty($import['name'])) ? FALSE: TRUE;
   $handle = _user_import_file_open($form['filepath']['#value'], $form['filename']['#value']);
   $data_row = _user_import_file_row($form['filename']['#value'], $handle);
-  
+
   $fieldmatch_description = t("Match columns in CSV file to profile fields, leave as '----' if there is no match.");
-  $fieldmatch_description .= '<br /><strong>' . t('Username') . ': </strong>' . t("The Username will be built from CSV columns in the order selected.");
-  $fieldmatch_description .= '<br /><strong>' . t('Abbreviate') . ': </strong>' . t("Use the first letter of a field in uppercase for the Username, e.g. 'john' -> 'J'.");
-  $fieldmatch_description .= '<br />' . t("If no CSV fields are selected, the Username will be randomly generated.");
-  
+  $fieldmatch_description .= '<br /><strong>'. t('Username') .': </strong>'. t("The Username will be built from CSV columns in the order selected.");
+  $fieldmatch_description .= '<br /><strong>'. t('Abbreviate') .': </strong>'. t("Use the first letter of a field in uppercase for the Username, e.g. 'john' -> 'J'.");
+  $fieldmatch_description .= '<br />'. t("If no CSV fields are selected, the Username will be randomly generated.");
+
   $form['field_match'] = array(
       '#type' => 'fieldset',
       '#title' => t('Field Match'),
       '#description' => $fieldmatch_description,
       '#weight' => -90,
       '#collapsible' => TRUE,
-      '#collapsed' => $collapsed, 
+      '#collapsed' => $collapsed,
       '#tree' => TRUE,
   );
 
   // add default and email address options
   $user_fields[0] = '-------------';
   $additional_user_fields = module_invoke_all('user_import_form_field_match');
-  
+
   foreach ($additional_user_fields as $type => $type_options) {
 
     foreach ($type_options as $field_id => $label) {
@@ -1051,60 +1065,60 @@ function user_import_form_field_match(&$
 
   $row = 0;
   $sort = array(t('no'), 1, 2, 3, 4);
-  
-  if (empty($data_row)) return; 
-    
-  foreach ($data_row as $data_cell) {        
+
+  if (empty($data_row)) return;
+
+  foreach ($data_row as $data_cell) {
 
       $form['field_match'][$row]= array(
           '#tree' => TRUE,
       );
- 
-      $form['field_match'][$row]['csv'] = array( 
+
+      $form['field_match'][$row]['csv'] = array(
           '#value' => check_plain(drupal_substr($data_cell, 0, 40)),
       );
-  
-      $form['field_match'][$row]['field_match'] = array( 
+
+      $form['field_match'][$row]['field_match'] = array(
           '#type' => 'select',
           '#default_value' => ($import['field_match'][$row]['field_match']) ? $import['field_match'][$row]['field_match'] : $user_fields[0],
           '#options' => $user_fields,
       );
 
-      $form['field_match'][$row]['username'] = array( 
+      $form['field_match'][$row]['username'] = array(
           '#type' => 'select',
           '#default_value' => ($import['field_match'][$row]['username']) ? $import['field_match'][$row]['username'] : $sort[0],
           '#options' => $sort,
       );
-      
-      $form['field_match'][$row]['abbreviate'] = array( 
+
+      $form['field_match'][$row]['abbreviate'] = array(
           '#type' => 'checkbox',
           '#default_value' => ($import['field_match'][$row]['abbreviate']) ? $import['field_match'][$row]['abbreviate'] : NULL,
       );
 
       $row++;
   }
- 
+
   return;
 }
- 
+
 function _user_import_create_username($order, $data, $abbreviate, $username_space) {
-    
+
     if (is_array($order)) {
-    
+
       asort($order);
       reset($order);
 
       $username = '';
 
       while (list ($file_column, $sequence) = each ($order)) {
-          
+
           if (!empty($username) && !empty($username_space)) $username .= ' ';
           $username .= ($abbreviate[$file_column] == 1) ? trim(drupal_strtoupper(chr(ord($data[$file_column])))) : trim($data[$file_column]);
       }
     }
-    
+
     if (empty($username)) $username = _user_import_random_username();
-    
+
     $username = _user_import_sanitise_username($username);
     $username = _user_import_unique_username($username);
     return $username;
@@ -1114,57 +1128,58 @@ function _user_import_create_username($o
  *  conform to Drupal username rules
  */
 function _user_import_sanitise_username($username) {
-  
-	// username cannot contain an illegal character
-	$username = preg_replace('/[^a-zA-Z0-9@ ]/', ' ', $username);
-	// username cannot contain multiple spaces in a row
-	$username = preg_replace('/[ ]+/', ' ', $username);   
-
-	// username must be less than 56 characters
-	$username = substr($username, 0, 56);
-
-	// username cannot begin or end with a space
-	$username = trim($username); 
-	return $username;
+
+  // username cannot contain an illegal character
+  $username = preg_replace('/[^a-zA-Z0-9@ ]/', ' ', $username);
+  // username cannot contain multiple spaces in a row
+  $username = preg_replace('/[ ]+/', ' ', $username);
+
+  // username must be less than 56 characters
+  $username = drupal_substr($username, 0, 56);
+
+  // username cannot begin or end with a space
+  $username = trim($username);
+  return $username;
 }
 
 /**
- *  deal with duplicate usernames 
+ *  deal with duplicate usernames
  */
 function _user_import_unique_username($username) {
 
-	static $suffix = 1;
-	
-	if ($suffix < 2) {
-		$duplicate = db_result(db_query("SELECT uid from {users} where name = '%s' LIMIT 1", $username));
-	}
-	else {
-		$duplicate = db_result(db_query("SELECT uid from {users} where name = '%s' LIMIT 1", "$username $suffix"));
-	}
-
-	// loop until name is valid 
-	if (!empty($duplicate)) {
-	  $suffix++;
-	  _user_import_unique_username($username);
-	}
-	
-	// add number at end of username if it already exists
-	$username = ($suffix < 2) ? $username : "$username $suffix";
-	return $username;
+  static $suffix = 1;
+
+  if ($suffix < 2) {
+    $duplicate = db_result(db_query_range("SELECT uid from {users} where name = '%s'", $username, 0, 1));
+  }
+  else {
+    $usern = $username .' '. $suffix;
+    $duplicate = db_result(db_query_range("SELECT uid from {users} where name = '%s'", $usern, 0, 1));
+  }
+
+  // loop until name is valid
+  if (!empty($duplicate)) {
+    $suffix++;
+    _user_import_unique_username($username);
+  }
+
+  // add number at end of username if it already exists
+  $username = ($suffix < 2) ? $username : "$username $suffix";
+  return $username;
 }
 
 function _user_import_profile($key = 'fid', $return_value = NULL) {
-    
-    if (!module_exists('profile')) return; 
-    
+
+    if (!module_exists('profile')) return;
+
     static $fields_static;
-    
+
     // avoid making more than one database call for profile info
     if (empty($fields_static)) {
-    
+
         $results = db_query("SELECT * FROM {profile_fields}");
-                
-        while ($row = db_fetch_object($results)) { 
+
+        while ($row = db_fetch_object($results)) {
             // don't include private fields
             if (user_access('administer users') || $row->visibility != PROFILE_PRIVATE) {
                 $fields_static[] = $row;
@@ -1173,26 +1188,26 @@ function _user_import_profile($key = 'fi
     }
 
     if (empty($fields_static)) return;
-   
+
     // return all profile fields info, or just specific type
     if (empty($return_value)) {
-        
+
         foreach ($fields_static as $field) {
             $fields[$field->{$key}] = $field;
         }
-    } 
+    }
     else {
         foreach ($fields_static as $field) {
             $fields[$field->{$key}] = $field->{$return_value};
         }
     }
-    
-    asort($fields);    
+
+    asort($fields);
     return $fields;
 }
 
 function _user_import_settings_save($settings) {
- 
+
     // move settings into 'options' column
     // 'options' column will be used to store new control options - instead of creating a new column for each option
     $settings['options']['groups'] = $settings['groups'];
@@ -1200,73 +1215,68 @@ function _user_import_settings_save($set
     $settings['options']['existing_og_subject'] = $settings['existing_og_subject'];
     $settings['options']['existing_og_markup'] = $settings['existing_og_markup'];
     $settings['options']['existing_og_message'] = $settings['existing_og_message'];
-    $settings['options']['existing_og_css'] = $settings['existing_og_css'];   
+    $settings['options']['existing_og_css'] = $settings['existing_og_css'];
 
     $settings['options']['subject'] = $settings['subject'];
     $settings['options']['message'] = $settings['message'];
     $settings['options']['message_format'] = $settings['message_format'];
     $settings['options']['message_css'] = $settings['message_css'];
-    
+
     $settings['options']['activate'] = $settings['activate'];
     $settings['options']['subscribed'] = $settings['subscribed'];
     $settings['options']['update_users'] = $settings['update_users'];
-    
+
     // Update settings for existing import
     if ($settings['import_id']) {
-    
-        db_query("UPDATE {user_import} 
-            SET name = '%s', filename = '%s', oldfilename = '%s', filepath = '%s', pointer = %d, processed = %d, valid= %d, first_line_skip = %d, contact = %d, username_space = %d, send_email = %d, field_match = '%s', roles = '%s', options = '%s', setting = '%s' 
+
+        db_query("UPDATE {user_import}
+            SET name = '%s', filename = '%s', oldfilename = '%s', filepath = '%s', pointer = %d, processed = %d, valid= %d, first_line_skip = %d, contact = %d, username_space = %d, send_email = %d, field_match = '%s', roles = '%s', options = '%s', setting = '%s'
             WHERE import_id = %d
             ", trim($settings['name']), $settings['filename'], $settings['oldfilename'], $settings['filepath'], $settings['pointer'], $settings['processed'], $settings['valid'], $settings['first_line_skip'], $settings['contact'], $settings['username_space'], $settings['send_email'], serialize($settings['field_match']), serialize($settings['roles']), serialize($settings['options']), $settings['setting'], $settings['import_id']);
-        
+
         // Save settings for new import
-    } 
+    }
     else {
-    
-        db_query("INSERT INTO {user_import} 
-            (name, filename, oldfilename, filepath, started, pointer, processed, valid, first_line_skip, contact, username_space, send_email, field_match, roles, options, setting) 
+
+        db_query("INSERT INTO {user_import}
+            (name, filename, oldfilename, filepath, started, pointer, processed, valid, first_line_skip, contact, username_space, send_email, field_match, roles, options, setting)
             VALUES ('%s', '%s', '%s', '%s', %d, %d, %d, %d, %d, %d, %d, %d, '%s', '%s', '%s', '%s')
             ", trim($settings['name']), $settings['filename'], $settings['oldfilename'], $settings['filepath'], time(), $settings['pointer'], $settings['processed'], $settings['valid'], $settings['first_line_skip'], $settings['contact'], $settings['username_space'], $settings['send_email'], serialize($settings['field_match']), serialize($settings['roles']), serialize($settings['options']), $settings['setting']);
-            
+
         $settings['import_id'] = db_result(db_query("SELECT LAST_INSERT_ID()"));
     }
-    
+
     return $settings;
 }
 
-// Update settings for existing import 
+// Update settings for existing import
 function _user_import_settings_update($pointer, $processed, $valid, $setting, $import_id) {
 
-	if (empty($import_id)) return;
-	db_query("UPDATE {user_import} SET pointer = %d, processed = %d, valid= %d, setting = '%s' WHERE import_id = %d", $pointer, $processed, $valid, $setting, $import_id);
+  if (empty($import_id)) return;
+  db_query("UPDATE {user_import} SET pointer = %d, processed = %d, valid= %d, setting = '%s' WHERE import_id = %d", $pointer, $processed, $valid, $setting, $import_id);
 }
 
 function _user_import_errors_display_save($import_id, $data, $email, $errors) {
-
-    $data['email'] = $email;
-
-    db_query("INSERT INTO {user_import_errors} 
-        (import_id, data, errors) 
-        VALUES (%d, '%s', '%s')
-        ", $import_id, serialize($data), serialize($errors));
-     return;
+  $data['email'] = $email;
+  db_query("INSERT INTO {user_import_errors} (import_id, data, errors) VALUES (%d, '%s', '%s')", $import_id, serialize($data), serialize($errors));
+  return;
 }
 
 function _user_import_settings_select($import_id = NULL, $template = FALSE) {
-         
+
     if (!empty($import_id) && !is_numeric($import_id)) return;
-    
+
     if (!empty($import_id)) {
-    
-        $import = db_fetch_array(db_query("SELECT * FROM {user_import} WHERE import_id = %d LIMIT 1", $import_id));
+
+        $import = db_fetch_array(db_query_range("SELECT * FROM {user_import} WHERE import_id = %d", $import_id, 0, 1));
         $import['field_match'] = unserialize($import['field_match']);
         $import['roles'] = unserialize($import['roles']);
         $import['options'] = unserialize($import['options']);
-    
-    } 
+
+    }
     else {
-        
-        $query = ($template) ? "SELECT * FROM {user_import} WHERE setting = 'template'" : "SELECT * FROM {user_import} WHERE setting != 'template' ORDER BY started DESC";
+
+        $query = ($template) ? "SELECT * FROM {user_import} WHERE setting = 'template'" : "SELECT * FROM {user_import} WHERE setting <> 'template' ORDER BY started DESC";
         $results = db_query($query);
         while ($row = db_fetch_array($results)) {
             $row['field_match'] = unserialize($row['field_match']);
@@ -1275,8 +1285,8 @@ function _user_import_settings_select($i
             $import[] = $row;
         }
     }
-      
-    return $import;      
+
+    return $import;
 }
 
 function _user_import_settings_deletion($import_id) {
@@ -1291,44 +1301,44 @@ function _user_import_random_username() 
     $vowels = 'aoueiy';
     $consonants = 'bcdfghjklmnpqrstvwxz';
     $length = 8;
-    
-    mt_srand ((double) microtime() * 10000000);
+
+    mt_srand((double) microtime() * 10000000);
     $next_vowel = 0;
-    
+
     for ($count = 0; $count <= $length; $count++) {
 
         if ($next_vowel) {
             $rand = mt_rand(0, 5);
-            $username.= $vowels{$rand};
+            $username .= $vowels{$rand};
             $next_vowel = 0;
-    
-        } 
+
+        }
         else {
             $rand = mt_rand(0, 19);
             $username .= $consonants{$rand};
             $next_vowel = 1;
         }
     }
-    
+
     return $username;
 }
 
 // Clean file - in case of incompatable line endings
 function _user_import_file_cleaner($filepath) {
 
-    $file = fopen($filepath,'r+');
-    while (!feof($file )){
-       $line = chop(fgets($file,4096));
-       $return = ereg_replace(chr(13) . chr(10), "\n", $line);
-       $return = ereg_replace(chr(13), "\n", $return);
-       fwrite($file, $return);
+    $file = fopen($filepath, 'r+');
+    while (!feof($file)) {
+      $line = chop(fgets($file, 4096));
+      $return = ereg_replace(chr(13) . chr(10), "\n", $line);
+      $return = ereg_replace(chr(13), "\n", $return);
+      fwrite($file, $return);
     }
-    
+
     fclose($file);
     return;
 }
-	
-function _user_import_process($settings) {	
+
+function _user_import_process($settings) {
 
     user_import_load_supported();
     $line_max = variable_get('user_import_line_max', 1000);
@@ -1336,15 +1346,16 @@ function _user_import_process($settings)
     $field_match = _user_import_unconcatenate_field_match($settings['field_match']);
 
     $handle = @fopen($settings['filepath'], "r");
-    
+
     // move pointer to where test/import last finished
     if ($settings['pointer'] != 0) fseek ($handle, $settings['pointer']);
-  
+
     // start count of imports on this cron run
     $send_counter = 0;
-    
+    $password = '';
+    $fields = '';
     while ($data = fgetcsv($handle, $line_max, ',')) {
-    
+
         $errors = user_import_errors(FALSE, TRUE);
 
         // if importing, check we are not over max number of imports per cron
@@ -1355,9 +1366,9 @@ function _user_import_process($settings)
 
         // don't process empty lines
         $line_filled = (count($data) == 1 && drupal_strlen($data[0]) == 0) ? FALSE : TRUE;
-        
+
         if ($line_filled) {
-        
+
             // check if this is first line - if so should we skip?
             if (!empty($settings['first_line_skip']) && $settings['processed'] == 0) {
                 // reset to false on second process
@@ -1381,7 +1392,7 @@ function _user_import_process($settings)
                     }
                     // Read in data if present for concatenating a user name.
                     if ($column_settings['username'] > 0) {
-                            
+
                         $username_data[$column_id] = $data[$column_id];
                         $username_order[$column_id] = $column_settings['username'];
                         $username_abbreviate[$column_id]= $column_settings['abbreviate'];
@@ -1392,72 +1403,77 @@ function _user_import_process($settings)
                 $errors = user_import_errors();
                 $account = array();
 
+                if ($fields['user']['delete'][0] == 'yes') {
+                  $existing = user_load(array('mail' => $fields['user']['email'][0]));
+                  user_delete($existing, $existing->uid);
+                  continue;
+                }
+
                 $account_additions = module_invoke_all('user_import_pre_save', $settings, $account, NULL, $fields, $errors);
 
-                foreach($account_additions as $field_name => $value) {
+                foreach ($account_additions as $field_name => $value) {
                   $account[$field_name] = $value;
-                } 
+                }
 
                 if (empty($errors)) {
                     if ($settings['setting'] == 'import') {
                         // If we update existing users matched by email (and
                         // therefore passed validation even if this email
                         // already exists), look for and use an existing account.
-                        if (!empty($settings['options']['update_users']) && $existing = user_load(array('mail' => $account['mail']))) {
 
-													$account = user_save($existing, $account);
+                        if (!empty($settings['options']['update_users']) && $existing = user_load(array('mail' => $account['mail']))) {
+                          $account = user_save($existing, $account);
                         }
                         else {
                           // Only set a user name if we are not updating an existing record.
                           $account['name'] = _user_import_create_username($username_order, $username_data, $username_abbreviate, $settings['username_space']);
                           $account = user_save('', $account);
                         }
-
-                     		module_invoke_all('user_import_after_save', $settings, $account, $password, $fields);
+                        module_invoke_all('user_import_after_save', $settings, $account, $password, $fields);
                         $send_counter++;
                     }
-                
+
                     $settings['valid']++;
                 }
-            
+
                 $settings['processed']++;
             }
-       
+
             $settings['pointer'] = ftell($handle);
-        
+
             // save lines that have fatal errors
             if (!empty($errors)) _user_import_errors_display_save($settings['import_id'], $fields, $account['email'], $errors);
         }
     }
-    
-    fclose ($handle);
+
+    fclose($handle);
     if ($settings['setting'] == 'import' && !$finished) $settings['setting'] = 'imported';
     if ($settings['setting'] == 'test') $settings['setting'] = 'tested';
-		_user_import_settings_update($settings['pointer'], $settings['processed'], $settings['valid'], $settings['setting'], $settings['import_id']);  
+    _user_import_settings_update($settings['pointer'], $settings['processed'], $settings['valid'], $settings['setting'], $settings['import_id']);
     return $settings;
 }
 
 function user_import_usernames_invalid($delete = NULL) {
-    
-    $users = db_query("SELECT uid, name, mail from {users} WHERE uid != 0 AND uid != 1");
-    
+
+    $users = db_query("SELECT uid, name, mail from {users} WHERE uid <> 0 AND uid <> 1");
+
     while ($user = db_fetch_object($users)) {
-        
+
         $error = user_validate_name($user->name);
-        
+
         if (!empty($error)) {
             $errors[$user->uid]['uid'] = $user->uid;
             $errors[$user->uid]['mail'] = $user->mail;
             $errors[$user->uid]['name'] = $user->name;
             $errors[$user->uid]['error'] = $error;
-            
+
             if (!empty($delete)) {
-                $form_values['account'] = $user;
-                user_confirm_delete_submit($form_id, $form_values);
+                $form_state['values']['account'] = $user;
+                user_confirm_delete_submit($form, $form_state['values']);
             }
         }
     }
-    
+
     $output = theme('user_import_username_errors', $errors);
     return $output;
 }
